package models

import (
	"github.com/beego/beego/v2/client/orm"
	"time"
)

// CompanyRemindRecord 客户提醒记录
type CompanyRemindRecord struct {
	CompanyRemindRecordId int `orm:"column(company_remind_record_id);pk"`
	Type             int `description:"过期类型，1:1天，2:7天，3:15天；4:30天"`
	SellerId             int `description:"销售id"`
	SellerName            string `description:"销售名称"`
	CompanyId             int `description:"客户id"`
	CompanyName            string `description:"客户名称"`
	Status                string `description:"客户状态"`
	EndDate               string `description:"到期日期"`
	UniqueCode            string `description:"唯一code"`
	CreateTime            time.Time
}

// AddMultiCompanyRemindRecord 批量添加客户提醒记录
func AddMultiCompanyRemindRecord(list []*CompanyRemindRecord) (err error) {
	if len(list) <= 0 {
		return
	}
	o := orm.NewOrm()
	_, err = o.InsertMulti(len(list), list)
	return
}