package services

import (
	"context"
	"encoding/json"
	"fmt"
	"hongze/hongze_task/models/roadshow"
	"hongze/hongze_task/utils"
	"strconv"
	"time"
)

func SendCalendarResearcherQuestionTips(cont context.Context) (err error) {
	utils.FileLog.Info("start SendCalendarResearcherQuestionTips")
	endTime := time.Now().Add(-2 * time.Second).Format(utils.FormatDateTime)
	list, err := roadshow.GetCalendarTesearcherQuestionTips(endTime)
	if err != nil {
		fmt.Println("SendCalendarResearcherQuestionTips Err:" + err.Error())
		utils.FileLog.Info("GetCalendarTesearcherQuestionTips Err:" + err.Error())
		return
	}

	var redirectUrl string

	redirectUrl = `/pages-approve/activity/detail?RsCalendarResearcherId=`
	for _, v := range list {
		var openIdArr []string
		openIdArr = append(openIdArr, v.OpenId)

		keyword1 := v.CompanyName + "路演已结束，请及时填写客户回答"
		//redirectUrl = fmt.Sprintf(redirectUrl, strconv.Itoa(v.RsCalendarResearcherId), strconv.Itoa(v.RsCalendarId))
		redirectUrl = redirectUrl + strconv.Itoa(v.RsCalendarResearcherId) + "&RsCalendarId=" + strconv.Itoa(v.RsCalendarId)
		sendInfo := new(SendWxTemplate)
		sendInfo.WxAppId = utils.AdminWxAppId
		sendInfo.Keyword1 = keyword1
		sendInfo.Keyword2 = "待填写"
		sendInfo.RedirectUrl = redirectUrl
		sendInfo.RedirectTarget = 2
		sendInfo.TemplateId = "rciDm9ThigRBGi1SZ4TFd74XA4aoAxSz_ugdv_tZ450"
		sendInfo.Remark = time.Now().Format(utils.FormatDateTime)
		sendInfo.OpenIdArr = openIdArr
		err = SendTemplateMsgV2(sendInfo)
		if err != nil {
			utils.FileLog.Info("GetCalendarTesearcherQuestionTips SendTemplateMsgV2 Err:" + err.Error())
			return
		}
		param, err := json.Marshal(sendInfo)
		utils.FileLog.Info("SendTemplateMsgV2 success:" + string(param))
		err = roadshow.ModifyRsCalendarResearcherQuestionMsgStatus(v.RsCalendarResearcherId)
		if err != nil {
			utils.FileLog.Info("ModifyRsCalendarResearcherQuestionMsgStatus Err:" + err.Error())
		}
	}
	utils.FileLog.Info("end SendCalendarResearcherQuestionTips")
	return
}
